/*
 * Copyright (C) 2012 Tokyo Institute of Technology 
 *
 * 
 * This file is part of MEGADOCK.
 * MEGADOCK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MEGADOCK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MEGADOCK.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


//============================================================================//
//
//  Software Name : MEGADOCK
//
//  Class Name : CPUTime
//
//  Contact address : Tokyo Institute of Technology, AKIYAMA Lab.
//
//============================================================================//

#include "cpu_time.h"

//============================================================================//
void CPUTime::initialize()
//============================================================================//
{
  control_initialize = 0.0;
  receptor_process = 0.0;
  docking_dock = 0.0;
  protein_lig_voxelization = 0.0;
  fftprocess_ligand_fft = 0.0;
  fftprocess_fft_inverse = 0.0;
  fftprocess_score_sort = 0.0;
  fftprocess_sort_index = 0.0;
  docking_output = 0.0;

  return;
}

//============================================================================//
void CPUTime::output()
//============================================================================//
{
  cout << "\nCPU time (initialize)        = " << control_initialize << " sec.\n";
  cout << "CPU time (receptor process)   = " << receptor_process << " sec.\n";
  cout << "CPU time (docking)            = " << docking_dock << " sec.\n";
  cout << "  | Ligand voxelization       = " << protein_lig_voxelization << " sec.\n";
  cout << "  | Ligand FFT                = " << fftprocess_ligand_fft << " sec.\n";
  cout << "  | Inverse FFT to get score  = " << fftprocess_fft_inverse << " sec.\n";
  cout << "  | Sort score (each core)    = " << fftprocess_score_sort << " sec.\n";
  cout << "  | Sort score (merge)        = " << fftprocess_sort_index << " sec.\n";
  cout << "CPU time (output)             = " << docking_output << " sec.\n";

  return;
}
