/*
 * Copyright (C) 2012 Tokyo Institute of Technology 
 *
 * 
 * This file is part of MEGADOCK.
 * MEGADOCK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MEGADOCK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MEGADOCK.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


//============================================================================//
//
//  Software Name : MEGADOCK
//
//  Class Name : CPUTime
//
//  Contact address : Tokyo Institute of Technology, AKIYAMA Lab.
//
//============================================================================//

#ifndef Cpu_time_h
#define Cpu_time_h 1

#include <string>
#include <iostream>

using namespace std;

class CPUTime
{
 private:
  friend class Control;
  friend class Docking;
  friend class FFTProcess;
  CPUTime(CPUTime &c){}
  const CPUTime & operator=(const CPUTime &c);
  float			control_initialize;
  float			receptor_process;
  float			docking_dock;
  float  		protein_lig_voxelization;
  float  		fftprocess_ligand_fft;
  float	  		fftprocess_fft_inverse;
  float	  		fftprocess_score_sort;
  float	  		fftprocess_sort_index;
  float			docking_output;
 public:
  CPUTime() {
#ifdef DEBUG
    cout << "Constructing CPUTime.\n";
#endif
  }
  virtual	~CPUTime()		{
#ifdef DEBUG
    cout << "Destructing CPUTime\n";
#endif
  }
  virtual void		initialize();
  virtual void		output();
};

#endif
